﻿var setPostContent,
    addMoreReply,
    clickLike,
    showClickLike,
    gotoTag,
    delReply,
    delComment,
    postComment,
    showCommentDialog,
    showAllComment,
    rawImg;
$(function () {

    //------------------------初始化-----------------------------
    var app, isLoading, tempLikeCount;


    //初始简化app对应接口
    if (window.hasOwnProperty("ChatGroupInterfaces")) {
        app = window.ChatGroupInterfaces;
    }
    //添加下拉刷新行为
    var droploadList = $('#lists').dropload({
        scrollArea: window,
        domDown: { // 下方DOM
            domClass: 'dropload-down',
            domRefresh: '',
            domLoad: '<div class="dropload-load"><span class="loading"></span>加载中...</div>',
            domNoData: '<div class="dropload-noData"></div>'
        },
        loadDownFn: function (me) {
            if (app) {
                if (isLoading) {
                    return;
                }
                isLoading = true;
                app.loadNextData();
            }
        }
    });

    //处理可能不支持导致的window没有高度
    $(document).ready(function () {
        $(window).load(function () {
            if ($(window).height() == 0) {
                $('.dropload-down').append('<div class="dropload-noData">快来抢沙发啦O(∩_∩)O~</div>');
            }
            if (isLoading) {
                return;
            }
            isLoading = true;
            app.loadNextData();

        });
    });

    //----------------------android接口-----------------
    /**
     * 设置帖子内容
     *
     * @param uId           id
     * @param avatar        头像
     * @param nick          昵称
     * @param time          日期
     * @param title         标题
     * @param message       内容
     * @param likeCount     点赞人数
     * @param like          是否已点赞
     * @param form          来自
     * @param isShowTag     是否显示来自哪里
     */
    setPostContent = function (uId, avatar, nick, time, title, message, likeCount, like, form, isShowTag) {
        tempLikeCount = likeCount;
        var html = '<div class="person person-bz">\
        <i class="baz-ibg"></i>\
            <a class="pson-tx" href="javascript:gotoUserInfo(' + uId + ')"><img src="' + avatar + '"></a>\
                <div class="pson-info">\
                    <div class="bzhu-ico cf"><p class="name">' + nick + '</p><span class="self">楼主</span></div>\
                    <div><span class="time">' + time + '</span></div>\
                </div>\
            </div>\
            <div class="post-txt"><h2>' + title + "</h2><p>" + message + '<p></div>' +
            (like == 1 ? ('<div class="like liked"><a><i class="ico i-like"></i>' + likeCount + '</a></div>') : ('<div class="like"><a href="javascript:clickLike()"><i class="ico i-like"></i>' + likeCount + '</a><span>+1</span></div>'));
        if (isShowTag == 1) {
            html += '<div class="form">来自：<a href="javascript:gotoTag()">' + form + '</a></div>';
        }
        $(".post-info").html(html);
    };

    /**
     * 加载更多回复
     * @param json          json数据字符串
     * @returns {boolean}
     */
    addMoreReply = function (json) {
        var jsonData = json; // eval('(' + json.toString() + ')');
        var replys = jsonData.data;
        var result = "";
        var lng = replys.length;
        for (var i = 0; i < lng; i++) {
            var reply = replys[i];
            result += '<li>\
                <div class="person' +
                (reply.host ? (' person-bz"><i class="baz-ibg"></i>') : ('">')) +
                (reply.admin ? ('<a href="javascript:delReply(' + reply.id + ')" class="ico i-del"></a>') : ('<a href="javascript:postComment(' + reply.id + ',' + reply.uid + ',\'' + reply.nick + '\')" class="ico i-say"></a>')) +
                '<a class="pson-tx" href="javascript:gotoUserInfo(' + reply.uid + ')"><img src="' + reply.avatar + '"></a>\
                <div class="pson-info">' +
                (reply.host ? ('<div class="bzhu-ico cf"><p class="name">' + reply.nick + '</p><span class="self">楼主</span></div>') : ('<p class="name">' + reply.nick + '</p>')) +
                '<span class="time">' + reply.time + '</span></div>\
                </div>\
                </div>\
                <div class="says-info"><div class="comment"><p>' + reply.message + '</p></div>';
            var comments = reply.comments;
            var clng = comments.length;
            if (clng != 0) {
                result += '<div class="reply"><i class="ico i-rep"></i>\
                    <div id="comment_dialog_' + reply.id + '" class="cancel" style="top:-32px;display: none;"><i class="ico i-no"></i><a id="comment_dialog_del_' + reply.id + '" href="#">删除</a><a>取消</a>\
                    </div>';
                for (var j = 0; j < clng; j++) {
                    var comment = comments[j];
                    result += '<p id="comment_' + comment.id + '"onclick="javascript:showCommentDialog(' + reply.id + ',' + comment.id + ',' + comment.uid + ',\'' + comment.nick + '\',' + comment.admin + ')"><span>' + comment.nick + '：</span><em>' + comment.message + '</em></p>';
                    if (j == 2) {
                        result += '<div id="more_comment_' + reply.id + '" style="display: none;">';
                    }
                }
                if (clng > 3) {
                    result += '</div><a id="click_more_' + reply.id + '" href="javascript:showAllComment(' + reply.id + ')" class="more">点击查看更多回复</a>';
                }
                result += '</div>';
            }
            result += '</div>';
            result += '</li>';
        }
        $('.post-list').append(result);
        if (jsonData.page >= jsonData.totalpage) {
            droploadList.lock();
            droploadList.noData();
        }
        droploadList.resetload();
        if (jsonData.totalpage == 0) {
            $('.dropload-noData').html('快来抢沙发啦O(∩_∩)O~');
        } else {
            $('.dropload-noData').html('');
        }
        isLoading = false;
    }
    //----------------------JS接口----------------------
    /**
     * 点赞
     */
    clickLike = function () {
        app.clickLike();
    };

    /**
     * 显示点赞动画
     */
    showClickLike = function () {
        tempLikeCount++;
        $(".like").html('<a><i class="ico i-like"></i>' + tempLikeCount + '</a><span>+1</span>');
        $(".like").addClass("liking");
    };

    /**
     * 跳转到圈子
     */
    gotoTag = function () {
        app.gotoTag();
    }

    /**
     * 删除回帖
     * @param replyId
     */
    delReply = function (replyId) {
        app.delReply("" + replyId);
    };

    /**
     * 删除评论
     * @param commentId
     */
    delComment = function (commentId) {
        app.delComment("" + commentId);
    };

    /**
     * 发布评论
     * @param commentId
     * @param uid
     * @param nick
     */
    postComment = function (commentId, uid, nick) {
        app.postComment("" + commentId, "" + uid, "" + nick);
    };

    /**
     * 跳转到用户面板
     */
    gotoUserInfo = function (userId) {
        app.gotoUserInfo("" + userId);
    };
    //----------------------HTML显示效果----------------
    /**
     * 显示回复的弹窗
     * @param post      当前回复
     */
    /**
     * 显示回复的弹窗
     * @param replyId       当前回复的id
     * @param commentId     当前评论的id
     * @param commentId     当前评论的昵称
     * @param admin         是否可以管理
     */
    showCommentDialog = function (replyId, commentId, uid, nick, admin) {
        var reply = $("#comment_dialog_" + replyId);
        var comment = $("#comment_" + commentId);
        var del = $("#comment_dialog_del_" + replyId);
        //移除其他的on
        $(".on").removeClass("on");
        if (admin) { //判断管理权限
            del.css("color", "#fff");
            del.attr("href", 'javascript:delComment(' + commentId + ')');
        } else {
            return;
            /* del.css("color", "#999");
            del.attr("href", 'javascript:postComment(' + commentId + ',' + uid + ',\'' + nick + '\')'); */
        }
        //选中该回复
        comment.addClass("on");
        //移动并显示弹窗
        reply.css("top", -40 + parseInt(comment.position().top));
        reply.css('display', 'block');
        //外部加监听
        $(document).one("click", function () { //对document绑定一个隐藏Div方法
            reply.css('display', 'none');
            $(".on").removeClass("on");
            event.stopImmediatePropagation(); //阻止事件向上冒泡
        });
        event.stopImmediatePropagation(); //阻止事件向上冒泡
    };

    /**
     * 显示所有回复
     * @param replyId
     */
    showAllComment = function (replyId) {
        //点击的按钮隐藏
        $('#click_more_' + replyId).css('display', 'none');
        //显示更多
        $('#more_comment_' + replyId).css('display', 'block');
    };

    /**
     *  图片点击处理
     */
    rawImg = function (imageId, img) {

        if ($(img).parent('a').length > 0) return true;
        window.location.href = "http://p.img4399.com/" + imageId + "/1";
        return true;
    };

    /**
     * 调整置顶图标
     */
    $(window).on("scroll", function () {
        var top = $(this).scrollTop(); // 当前窗口的滚动距离
        if (top > 540) {
            $('.i-back').css('display', 'block');
        } else {
            $('.i-back').css('display', 'none');
        }
    });
    $('.i-back').css('display', 'none');
    $('.i-back').on("click", function () {
        $(window).scrollTop(0);
    });
});